# RoboQuality Project

Main repo for the RoboQuality project. Every workpackages is organized in an own repository and added as submodules to this main repository. 

## Installation

1. Clone repo. Check if all submodules are downloaded to the `pkg` folder recursivly. 
2. Install ROS2 Humble (LTS version):   
https://docs.ros.org/en/rolling/Releases/Release-Humble-Hawksbill.html 
3. Sources ROS2
4. Build the modules. Use the following command from the main folder of this repo:   
```colcon build . ```
5. Launch all or single modules.

### Folder Structure (after building)


```
.  
├── build                    # Builded packages ...
│   ├── ...  
├── install                  # Local workspace ...
│   ├── local_setup.bash  
│   ├── ...  
├── log                      # Build and node logs ...
│   ├── ...  
├── pkg                      # Submodules
│   ├── rq_controller  
│   ├── rq_ddetection  
│   ├── rq_hardware  
│   ├── rq_interfaces  
│   └── rq_trajectory  
└── README.md  

```

## Packages Overview

| Submodule          | Describtion                                   |  Link                                                                      |
|--------------------|-----------------------------------------------|----------------------------------------------------------------------------|
| `Controller`       |  Workflow controller. Holds all information.  | [rq_controller](https://mygit.th-deg.de/roboct/robo_quality/rq_controller) |
| `Defect Detection` |  Defect detection module                      | [rq_ddetection](https://mygit.th-deg.de/roboct/robo_quality/rq_ddetection) |
| `Hardware`         |  Interface to real / simulated system         | [rq_hardware](https://mygit.th-deg.de/roboct/robo_quality/rq_hardware)     |
| `Trajectory`       |  CT-Trajectory optimization                   | [rq_trajectory](https://mygit.th-deg.de/roboct/robo_quality/rq_trajectory) |
| `Interfaces`       |  project intern interfaces for all msg / srv. | [rq_interfaces](https://mygit.th-deg.de/roboct/robo_quality/rq_interfaces) |


